Index: trunk/kernel/drivers/soclib/soclib_bdv.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_bdv.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_bdv.h	(revision 1)
@@ -0,0 +1,105 @@
+/*
+ * soclib_bdv.h - SOCLIB_BDV (simple block device) driver definition.
+ *
+ * Author    Alain Greiner
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_BDV_H_
+#define _SOCLIB_BDV_H_
+
+#include <device.h>
+#include <hal_types.h>
+
+/********************************************************************************************
+ * This driver supports the SocLib VciBlockDevice component, that is a simgle channel,
+ * block oriented, external storage controler, supporting only one I/O transaction,
+ * at a given time.
+ *******************************************************************************************/
+
+/********************************************************************************************
+ *       SOCLIB_BDV registers offset 
+ *******************************************************************************************/
+
+enum SoclibBlockDeviceRegisters
+{
+    BDV_BUFFER_REG     = 0,
+    BDV_LBA_REG	       = 1,
+    BDV_COUNT_REG      = 2,
+    BDV_OP_REG	       = 3,
+    BDV_STATUS_REG	   = 4,
+    BDV_IRQ_ENABLE_REG = 5,
+    BDV_SIZE_REG       = 6,
+    BDV_BLOCK_SIZE_REG = 7,
+    BDV_BUFFER_EXT_REG = 8,
+};
+
+/********************************************************************************************
+ *       SOCLIB_BDV status values
+ *******************************************************************************************/
+
+#define BDV_IDLE	        0
+#define BDV_BUSY	        1
+#define BDV_READ_SUCCESS	2
+#define BDV_WRITE_SUCCESS	3
+#define BDV_READ_ERROR	    4
+#define BDV_WRITE_ERROR	    5
+#define BDV_ERROR	        6
+
+/********************************************************************************************
+ *        SOCLIB_BDV operations 
+ *******************************************************************************************/
+
+#define BDV_OP_NOP          0
+#define BDV_OP_READ         1
+#define BDV_OP_WRITE        2
+
+/********************************************************************************************
+ * This function access the SOCLIB_BDV hardware registers to get the block size and the
+ * number of blocks, and initialises the "extension" field of the IOC device descriptor.
+ ********************************************************************************************
+ * @ dev_xp     : extended pointer on the generic IOC device descriptor.
+ *******************************************************************************************/
+extern void soclib_bdv_init( xptr_t dev_xp );
+
+/********************************************************************************************
+ * This function is called by the server thread associated to the IOC device.
+ * It decode the IOC device command embedded in the calling thread descriptor,
+ * (format defined in the dev_ioc.h file) and starts execution of this generic command, 
+ * accessing the relevant SOCLIB_BDV hardware registers.
+ * Then it blocks on the THREAD_BLOCKED_DEV_ISR and deschedule, because the SOCLIB_BDV 
+ * device cannot register several commands. It is re-activated by the ISR signaling the
+ * I/O operation completion.
+ ********************************************************************************************
+ * @ thread_xp  : extended pointer on the client thread.
+ *******************************************************************************************/
+extern void soclib_bdv_command( xptr_t thread_xp );
+
+/********************************************************************************************
+ * This Interrupt Service Routine is executed when the IRQ signaling the completion of 
+ * an IOC command is received by a core. It acknowledge the IRQ by accessing the proper
+ * SOCLIB_BDV register, unblock the client thread, and unblock the server thread that
+ * can starts execution of a new command if the waiting queue is not emppty.
+ ********************************************************************************************
+ * @ dev     : local pointer on the generic IOC device descriptor.
+ *******************************************************************************************/
+extern void soclib_bdv_isr( device_t * dev );
+
+
+#endif /* _BLOCK_H_ */
Index: trunk/kernel/drivers/soclib/soclib_cma.c
===================================================================
--- trunk/kernel/drivers/soclib/soclib_cma.c	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_cma.c	(revision 1)
@@ -0,0 +1,329 @@
+/*
+ * soclib_nic.c - SOCLIB_NIC (Network Interface Controler) driver implementation.
+ *
+ * Author     Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <device.h>
+#include <dev_nic.h>
+#include <soclib_nic.h>
+#include <spinlock.h>
+
+
+/////////////////////////////////////
+void soclib_nic_init( xptr_t xp_dev )
+{
+    uint32_t    i;
+    kmem_req_t  req;
+    
+    // get NIC device descriptor cluster and local pointer
+    cxy_t      dev_cxy  = GET_CXY( dev );
+    device_t * dev_ptr  = (device_t *)GET_PTR( dev );
+  
+    // get hardware device base address
+	xptr_t     base = hal_remote_lwd( XPTR( dev_cxy , &dev_ptr->base ) );
+
+    // get hardware device cluster and local pointer
+    cxy_t      nic_cxy  = GET_CXY( base );
+    uint32_t * nic_ptr  = (uint32_t *)GET_PTR( base );
+
+    // initialize Soclib NIC global registers 
+    hal_remote_sw( XPTR( nic_cxy , &nic_ptr + NIC_G_BC_ENABLE ) , 0 );
+    hal_remote_sw( XPTR( nic_cxy , &nic_ptr + NIC_G_ON        ) , 0 );
+
+    // allocate memory for chbuf descriptor (one page)
+    if( sizeof(nic_chbuf_t) > CONFIG_PPM_PAGE_SIZE )
+    {
+        printk("PANIC in %s : chbuf descriptor exceeds one page\n", __FUNCTION__ );
+        hal_core_sleep;
+    }
+
+    req->type   = KMEM_PAGE;
+    req->size   = 0;
+    req_flags   = AF_KERNEL;
+
+    nic_chbuf_t * chbuf = (nic_chbuf_t *)kmem_alloc( &req );
+
+    if( chbuf == NULL )
+    {
+        printk("PANIC in %s : no more memory for chbuf desccriptor\n", __FUNCTION__ );
+        hal_core_sleep;
+    }
+
+    // initialise chbuf state
+    chbuf->cont_id  = 0;
+    chbuf->pkt_id   = 0;
+    chbuf->word_id  = 34;
+    
+    // allocate containers (one page per container)
+    // and complete chbuf descriptor initialization
+    if( CONFIG_PPM_PAGE_SIZE != 4096 )
+    {
+        printk("PANIC in %s : chbuf container must be 4 Kbytes\n", __FUNCTION__ );
+        hal_core_sleep;
+    }
+
+    for( i = 0 ; i < CONFIG_NIC_CHBUF_DEPTH ; i++ )
+    {
+        uint32_t * container = (uint32_t *)kmem_alloc( req );   
+
+        if( container == NULL )
+        {
+            printk("PANIC in %s : no more memory for container\n", __FUNCTION__ );
+            hal_core_sleep;
+        }
+        
+        chbuf->cont[i] = container;
+        chbuf->full[i] = (paddr_t)XPTR( local_cxy , container );
+    }
+
+    // get a free WTI mailbox
+    uint32_t wti_id = dev_icu_wti_alloc();
+    if( wti_id == -1 )
+    {
+        printk("PANIC in %s : cannot allocate WTI mailbox\n", __FUNCTION__ );
+        hal_core_sleep;
+    }
+
+    // enable WTI IRQ in local ICU and update WTI interrupt vector
+    dev_icu_enable_irq( WTI_TYPE , wti_id , xp_dev );
+
+    // link NIC IRQ to WTI mailbox in PIC component 
+    uint32_t irq_id; 
+    if( is_rx ) irq_id = devices_irq.nic_rx[channel];
+    else        irq_id = devices_irq.nic_tx[channel];
+    dev_pic_bind_irq( irq_id , local_cxy , wti_id );
+
+} // end soclib_nic_init()
+
+
+////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_nic_cmd()
+{
+    uint32_t       cmd;          // command type    
+    char         * buffer;       // pointer on command buffer   
+    uint32_t       length;       // Ethernet packet length
+    uint32_t       offset;       // offset in buffer
+    nic_chbuf_t  * chbuf;        // pointer on chbuf descriptor
+    uint32_t       cont_id;      // index of current container in chbuf
+    uint32_t       pkt_id;       // index of current packet in container
+    uint32_t       word_id;      // index of first word of current packet in container
+    uint32_t     * container;    // pointer on container (array of uint32_t)
+    uint16_t     * header;       // pointer on container header (array of uint16_t)
+    uint32_t       npackets;     // number of packets in current container
+
+    volatile uint64_t  sts;  // container descriptor (containing status)
+
+    thread_t * this = CURRENT_THREAD;
+
+    // get command arguments
+    cmd    = this->dev.nic.cmd;
+    buffer = this->dev.nic.buffer;
+    length = this->dev.nic.length;
+
+    // get chbuf descriptor pointer
+    chbuf = (nic_chbuf_t *)dev->ext.nic.queue;
+
+    // analyse command type
+    switch( cmd )
+    {
+        /////////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_READ:   // transfer one packet from RX queue to command buffer
+        {
+            // get current container index
+            cont_id = chbuf->cont_id;
+            
+            if( chbuf->full[cont_id] == 0 )  // container empty
+            {
+                printk("PANIC in %s : read an empty container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // get pointer on container and header 
+            container = chbuf->cont[cont_id];
+            header    = (uint16_t *)header;
+
+            // get  expected packet index and first word index in container
+            pkt_id  = chbuf->pkt_id;
+            word_id = chbuf->word_id;
+
+            // get packet length and number of packets from container header
+            length    = header[pkt_id + 2];
+            npackets  = header[0];
+
+            if( pkt_id >= npackets )  // packet index too large
+            {
+                printk("PANIC in %s : read a non readable container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // move the packet from container to buffer
+            memcpy( buffer , container + word_id , length );
+
+            // update current packet index and first word index
+            chbuf->pkt_id  = pkt_id + 1;
+            if( length & 0x3 ) chbuf->word_id = word_id + (length>>2) + 1;
+            else               chbuf->word_id = word_id + (length>>2);
+        }
+        break;    // end READ
+            
+        //////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_WRITE:  // move one packet from command buffer to TX queue
+        {
+            // get current TX container indexes
+            cont_id = chbuf->cont_id;
+            pkt_id  = chbuf->pkt_id;
+            word_id = chbuf->word_id;
+
+            if( chbuf->full[cont_id] != 0 )  // container full
+            {
+                printk("PANIC in %s : write to a full container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // get pointer on container and header 
+            container = chbuf->cont[cont_id];
+            header    = (uint16_t *)container;
+
+            if( length > ((1024 - word_id)<<2) )  // packet length too large
+            {
+                printk("PANIC in %s : write to a non writable container\n", __FUNCTION__ );
+                hal_core_sleep();
+            }
+
+            // update packet length in container header
+            header[pkt_id + 2] = (uint16_t)length;
+
+            // move the packet from buffer to container
+            memcpy( container + word_id , buffer , length );
+
+            // update current packet index and first word index
+            chbuf->pkt_id  = pkt_id + 1;
+            if( length & 0x3 ) chbuf->word_id = word_id + (length>>2) + 1;
+            else               chbuf->word_id = word_id + (length>>2);
+        }
+        break;  // end WRITE
+
+        ////////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_WRITABLE:  // analyse chbuf status / update status if required
+        {
+            // get current container state 
+            cont_id = chbuf->cont_id;
+            word_id = chbuf->word_id;
+
+            // compute current container writable
+            bool_t ok = ( chbuf->full[cont_id] == 0 ) &&
+                        ( length <= ((1024 - word_id)<<2) );
+
+            if( ok )                // current container writable
+            {
+                // return chbuf writable
+                this->dev.nic.status = true;
+            }
+            else                    // current container not writable
+            {
+                // release current container
+                chbuf->full[cont_id] = 1;
+
+                // check next container 
+                cont_id = (cont_id + 1) % CONFIG_NIC_CHBUF_DEPTH;
+
+                if( chbuf->full[cont_id] == 0 ) // next container empty
+                {
+                    // update chbuf status
+                    chbuf->word_id = 34;
+                    chbuf->cont_id = cont-id;
+                    chbuf->pkt_id  = 0;
+                     
+                    // return chbuf writable
+                    this->dev.nic.status = true;
+                }
+                else                            // next container full     
+                {
+                    // return chbuf non writable
+                    this->dev.nic.status = false;
+                }
+            }
+        }
+        break;  // end WRITABLE
+
+        /////////////////////////////////////////////////////////////////////////////
+        case NIC_CMD_READABLE:  // analyse chbuf status / update status if required
+        {
+            // get current container state
+            cont_id  = chbuf->cont_id;
+            pkt_id   = chbuf->pkt_id;
+            npackets = chbuf->cont[cont_id][0] & 0x0000FFFF; 
+            
+            // compute current container readable
+            bool_t ok = ( chbuf->full[cont_id] == 1 ) &&
+                        ( pkt_id < npackets );
+
+            if( ok )                    // current container readable
+            {
+                // return chbuf readable     
+                this->dev.nic.status = true;
+            }
+            else                        // current container non readable
+            {
+                // release current container
+                chbuf->full[cont_id] = 0;
+
+                // check next container
+                cont_id = (cont_id + 1) % CONFIG_NIC_CHBUF_DEPTH;
+
+                if( chbuf->full[cont_id] == 1 ) // next container full 
+                {
+                    // update chbuf status
+                    chbuf->word_id = 34;
+                    chbuf->cont_id = cont-id;
+                    chbuf->pkt_id  = 0;
+                     
+                    // return chbuf readable
+                    this->dev.nic.status = true;
+                }
+                else                            // next container empty    
+                {
+                    // return chbuf non readable
+                    this->dev.nic.status = false;
+                }
+            }
+   
+        }
+        break;  // end READABLE
+    } 
+} // end soclib_nic_cmd()
+
+
+////////////////////////////////////////////////////////////////
+void __attribute__ ((noinline)) soclib_nic_isr( device_t * dev )
+{
+    cxy_t local_cxy = LOCAL_CUSTER->cxy;
+
+    // acknowledge WTI IRQ TODO
+
+    // unblock server thread 
+    thread_t * server = dev->server;
+    thread_unblock( XPTR( local_cxy , server ) , THREAD_BLOCKED_IO );
+
+} // end soclib_nic_isr()
+
+
+
Index: trunk/kernel/drivers/soclib/soclib_cma.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_cma.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_cma.h	(revision 1)
@@ -0,0 +1,216 @@
+/*
+ * soclib_nic.h - SOCLIB_NIC (Network Interface Controler) driver definition.
+ *
+ * Author    Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_NIC_H_
+#define _SOCLIB_NIC_H_
+
+#include <device.h>
+#include <hal_types.h>
+
+/********************************************************************************************
+ * This driver supports both the Soclib VciMultiNic component, that is a GMII compliant
+ * Gigabit Ethernet controler, and the associated VciChbufDma component, that is a chained
+ * buffers DMA controler, in charge of moving packets between the NIC hardware buffers,
+ * and the kernel memory buffers.
+ *
+ * - The VciMultiNic component supports N channels, indexed by the source IP address
+ *   for the RX packets, and by the destination IP address for the TX packets. 
+ * - The VciChbufDma component contains 2*N channels, to support the N TX queues,
+ *   and the N RX  queues. 
+ * 
+ * The Ethernet packet length can have any value, between 64 to 1538 bytes.
+ * The data transfer unit between software and the NIC is a 4 Kbytes "container",
+ * containing an integer number of variable size packets.
+ *
+ * Each DMA TX or TX channel transfers an (infinite) stream of "containers" between 
+ * the hardware "chbuf" contained in the VciMultiNic hardware components, and the software 
+ * "chbuf" located in a given cluster kernel memory, and implementing the TX or RX queue.
+ * Each NIC channel contains one two-containers RX chbuf, and one two-containers TX chbuf.
+ *
+ * The max number of packets in a container is 66 packets.
+ * The first 34 words of a container are the container header :
+ *
+ *     word0  	| 	NB_WORDS	|	NB_PACKETS	|
+ *     word1	|	PLEN[0]		|	PLEN[1]		|
+ *      ...	    |	.......		|	........	|
+ *     word33	|	PLEN[64]	|	PLEN[65]	|
+ *
+ *  - NB_PACKETS is the actual number of packets in the container.
+ *	- NB_WORDS   is the number of useful words in the container.
+ *	- PLEN[i]    is the number of bytes for the packet[i].
+ *
+ * Packets are stored in the (1024 - 34) following words, and the packets are word-aligned.
+ *
+ * 	- The first 4 Kbytes contain the RX_0 container data
+ * 	- The next  4 Kbytes contain the RX_1 container data
+ * 	- The next  4 Kbytes contain the TX_0 container data
+ * 	- The next  4 Kbytes contain the TX_1 container data
+ * 	- The next  4 Kbytes contain the channel addressable registers:
+ *      * NIC_RX_STS_0      : RX_0 status               (read/write)
+ *      * NIC_RX_STS_1      : RX_1 status               (read/write)
+ *      * NIC_TX_STS_0      : TX_0 status               (read/write)
+ *      * NIC_TX_STS_1      : TX_1 status               (read/write)
+ *      * NIC_RX_DESC_LO_0  : RX_0 descriptor low word  (read/write)
+ *      * NIC_RX_DESC_HI_0  : RX_0 descriptor high word (read/write)
+ *      * NIC_RX_DESC_LO_1  : RX_1 descriptor low word  (read/write)
+ *      * NIC_RX_DESC_HI_1  : RX_1 descriptor high word (read/write)
+ *      * NIC_TX_DESC_LO_0  : TX_0 descriptor low word  (read/write)
+ *      * NIC_TX_DESC_HI_0  : TX_0 descriptor high word (read/write)
+ *      * NIC_TX_DESC_LO_1  : TX_1 descriptor low word  (read/write)
+ *      * NIC_TX_DESC_HI_1  : TX_1 descriptor high word (read/write)
+ * 		* NIC_MAC_4         : MAC @ 32 LSB bits         (read_only)
+ * 		* NIC_MAC_2         : MAC @ 16 MSB bits         (read_only)
+ *      * NIC_RX_RUN        : RX channel X activated    (write_only)
+ *      * NIC_TX_RUN        : TX channel X activated    (write_only)
+ *
+ * To access both the container status, and the data contained in the container, the DMA
+ * uses two physical addresses, that are packed in a 64 bits "container descriptor". 
+ * - desc[25:0]  contain bits[31:6] of the status physical address.
+ * - desc[51:26] contain bits[31:6] of the buffer physical address.
+ * - desc[63:52] contain the common 12 physical address extension bits.
+ * Both the buffer address and its status address must be 64 bytes aligned.
+ *******************************************************************************************/
+
+/********************************************************************************************
+ *       SOCLIB_NIC registers offset 
+ *******************************************************************************************/
+
+enum SoclibMultiNicHyperRegisters {
+    NIC_G_VIS                        = 0,    * bitfield : bit N = 0 -> channel N disabled
+    NIC_G_ON                         = 1,    * boolean : NIC component activated
+    NIC_G_NB_CHAN                    = 2,    * Number of channels (read only)
+    NIC_G_BC_ENABLE                  = 3,    * boolean : Enable Broadcast if non zero
+    NIC_G_TDM_ENABLE                 = 4,    * boolean : TDM Scheduler if non zero
+    NIC_G_TDM_PERIOD                 = 5,    * TDM time slot value
+    NIC_G_BYPASS_ENABLE              = 6,    * boolean : Enable bypass for TX packets
+    NIC_G_MAC_4                      = 8,    * channel mac address 32 LSB bits array[8]
+    NIC_G_MAC_2                      = 16,   * channel mac address 16 MSB bits array[8]
+    NIC_G_NPKT_RX_G2S_RECEIVED       = 32,   * number of packets received on GMII RX port
+    NIC_G_NPKT_RX_G2S_DISCARDED      = 33,   * number of RX packets discarded by RX_G2S FSM
+
+    NIC_G_NPKT_RX_DES_SUCCESS        = 34,   * number of RX packets transmited by RX_DES FSM
+    NIC_G_NPKT_RX_DES_TOO_SMALL      = 35,   * number of discarded too small RX packets (<60B)
+    NIC_G_NPKT_RX_DES_TOO_BIG        = 36,   * number of discarded too big RX packets (>1514B)
+    NIC_G_NPKT_RX_DES_MFIFO_FULL     = 37,   * number of discarded RX packets fifo full
+    NIC_G_NPKT_RX_DES_CRC_FAIL       = 38,   * number of discarded RX packets CRC32 failure
+
+    NIC_G_NPKT_RX_DISPATCH_RECEIVED  = 39,   * number of packets received by RX_DISPATCH FSM
+    NIC_G_NPKT_RX_DISPATCH_BROADCAST = 40,   * number of broadcast RX packets received
+    NIC_G_NPKT_RX_DISPATCH_DST_FAIL  = 41,   * number of discarded RX packets DST MAC not found
+    NIC_G_NPKT_RX_DISPATCH_CH_FULL   = 42,   * number of discarded RX packets for channel full
+
+    NIC_G_NPKT_TX_DISPATCH_RECEIVED  = 43,   * number of packets received by TX_DISPATCH FSM
+    NIC_G_NPKT_TX_DISPATCH_TOO_SMALL = 44,   * number of discarded too small TX packets (<60B)
+    NIC_G_NPKT_TX_DISPATCH_TOO_BIG   = 45,   * number of discarded too big TX packets (>1514B)
+    NIC_G_NPKT_TX_DISPATCH_SRC_FAIL  = 46,   * number of discarded TX packets SRC MAC failed
+    NIC_G_NPKT_TX_DISPATCH_BROADCAST = 47,   * number of broadcast TX packets received
+    NIC_G_NPKT_TX_DISPATCH_BYPASS    = 48,   * number of bypassed TX->RX packets
+    NIC_G_NPKT_TX_DISPATCH_TRANSMIT  = 49,   * number of transmit TX packets
+
+    NIC_CHANNEL_SPAN                 = 0x2000,
+};
+
+enum SoclibMultiNicChannelRegisters 
+{
+    NIC_RX_STS_0              = 0,    * RX_0 status (full or empty)      (Read/Write)
+    NIC_RX_STS_1              = 16,   * RX_1 status (full or empty)      (Read/Write)
+    NIC_TX_STS_0              = 32,   * TX_0 status (full or empty)      (Read/Write)
+    NIC_TX_STS_1              = 48,   * TX_1 status (full or empty)      (Read/Write)
+    NIC_RX_DESC_LO_0          = 64,   * RX_0 descriptor low word         (Read/Write)
+    NIC_RX_DESC_HI_0          = 65,   * RX_0 descriptor high word        (Read/Write)
+    NIC_RX_DESC_LO_1          = 66,   * RX_1 descriptor low word         (Read/Write)
+    NIC_RX_DESC_HI_1          = 67,   * RX_1 descriptor high word        (Read/Write) 
+    NIC_TX_DESC_LO_0          = 68,   * TX_0 descriptor low word         (Read/Write)
+    NIC_TX_DESC_HI_0          = 69,   * TX_0 descriptor high word        (Read/Write) 
+    NIC_TX_DESC_LO_1          = 70,   * TX_1 descriptor low word         (Read/Write)
+    NIC_TX_DESC_HI_1          = 71,   * TX_1 descriptor high word        (Read/Write) 
+    NIC_MAC_4                 = 72,   * channel mac address 32 LSB bits  (Read Only)
+    NIC_MAC_2                 = 73,   * channel mac address 16 LSB bits  (Read Only)
+    NIC_RX_RUN                = 74,   * RX packets can be received       (write_only)
+    NIC_TX_RUN                = 75,   * TX packets can be transmitted    (write_only)
+};
+
+
+
+/********************************************************************************************
+ * This structure defines the chained buffer descriptor, used to implement both
+ * the RX and TX packets queues. Each buffer in a chbuf (called container) is a 4 Kbytes
+ * buffer containing a variable number of packets. All containers are allocated in 
+ * the same cluster as the associated NIC device descriptor. The chbuf descriptor contains:
+ * - an array of container pointers cont[], used by the kernet threads to access the
+ *   packets contained in the containers.
+ * - an array of set/reset Boolean full[] used by both the software threads and 
+ *   by the hardware FSMs for lock-less synchronisation. 
+ * - an array of containers descriptors containing the physical addresses of the
+ *   "full[i]" and "cont[i]" variables, used by the DMA FSMs. and an array of set/reset
+ * Moreover, It contains three pointers (cont_id, pkt_id, and word_id) that are private
+ * variables used by the software thread to store the chbuf global state. 
+ *******************************************************************************************/
+
+typedef struct nic_chbuf_s
+{
+    uint32_t * cont[CONFIG_NIC_CHBUF_DEPTH]; /*! container virtual base address            */
+    uint32_t   full[CONFIG_NIC_CHBUF_DEPTH]; /*! Boolean : container full if non zero      */
+    uint64_t   desc[CONFIG_NIC_CHBUF_DEPTH]  /*! container & status physical addresses     */
+    uint32_t   cont_id;                      /*! current container index                   */
+    uint32_t   pkt_id;                       /*! current packet index in container         */
+    uint32_t   word_id;                      /*! first word of current packet              */
+}
+nic_chbuf_t;
+
+/********************************************************************************************
+ *        SOCLIB_NIC driver access functions 
+ *******************************************************************************************/
+
+/********************************************************************************************
+ * This function initializes the SOCLIB_NIC hardware registers, allocates memory for
+ * the RX and TX containers, alocates and initializes the RX and TX chbuf descriptors.
+ * It allocates one WTI mailbox for the IRQ signaling availability of an RX full container,
+ * or a TX empty container, and route the WTI IRQ to the core running the server thread.
+ ********************************************************************************************
+ * @ dev     : extended pointer on the generic NIC device descriptor.
+ *******************************************************************************************/
+extern void soclib_nic_init( xptr_t dev );
+
+/********************************************************************************************
+ * This function implement the READ / WRITE / READABLE / WRITABLE commands.
+ * - READABLE : returns in the command status a boolean true if a packet is available.
+ *   It update the RX queue read pointer if required.
+ * - READ : move a packet from the RX queue to the command buffer, and returns the packet
+ *   length in the command. The READABLE command must be called before the READ command.
+ * - WRITABLE : returns in the command status a boolean true if a packet with a given length
+ *   can be written in the TX queue. It update the RX queue read pointer if required.
+ * - WRITE : move a packet from the command buffer to the TX queue. The WRITABLE command
+ *   must be called before the WRITE command.
+ *******************************************************************************************/
+extern void soclib_nic_cmd();
+
+/********************************************************************************************
+ * TODO
+ ********************************************************************************************
+ * @ dev     : local pointer on the generic IOC device descriptor.
+ *******************************************************************************************/
+extern void soclib_nic_isr( device_t * dev );
+
+
+#endif /* _BLOCK_H_ */
